﻿init python:
    from copy import deepcopy
    def get_key():
        if event in pygame.event.get():
            if event.type == pygame.KEYDOWN:
                msg.msg("key down")
            if event.type == pygame.KEYUP:
                msg.msg("key up")
    def load_map(tilemap):
        map = []
        f = open(renpy.loader.transfn(tilemap),"r")
        for line in f:
            line = line.strip()
            divided = line.split(",")
            listed = [[x, []] for x in divided]
            map.append(listed)
        f.close()
        return map
    def load_tiles(img, size):
        tiles = []
        for i in range(8):
            for ii in range(8):
                tiles.append(Crop((ii*size,i*size,size,size), img))
        return tiles

    class tile:
        def __init__(self, image, type):
            self.image = image
            self.type = type

    class level_class:
        def __init__(self, name, size, map, objects = [], exits = [], npc = [], enemies = []):
            self.name = name
            self.size = size
            self.set = load_tiles(map[0], size)
            self.map = load_map(map[1])
            self.exits = exits
            self.npc = []
            for i in npc:
                i[0].x , i[0].y = i[1], i[2]
                self.npc.append(i[0])
            self.collisions = []
            for i in range(-1, 24):
                self.collisions.append(str(i))
            if objects:
                for i in objects:
                    self.map[i[1]][i[0]][1].append(i[2])
            self.enemies = []
            for i in enemies:
                self.spawn(i[0], i[1], i[2])

        def collide(self, actor, direction, x = 0, y = 0):
            if actor:
                x = actor.x
                y = actor.y
                if direction == "up":
                    y -= 1
                elif direction == "left":
                    x -= 1
                elif direction == "down":
                    y += 1
                elif direction == "right":
                    x += 1

            for i in self.enemies:
                if i.y == y:
                    if i.x == x:
                        return "enemy", i
            for i in self.npc:
                if i.y == y:
                    if i.x == x:
                        return "npc", i
            if hero.y == y:
                if hero.x == x:
                    return "player"
            if self.map[y][x][0] in self.collisions:
                return "wall"
            else:
                return False
        def spawn(self, enemy, x = None, y = None):
            if not x:
                while True:
                    x = renpy.random.randint(0, len(self.map[0])-1)
                    y = renpy.random.randint(0, len(self.map)-1)
                    if not self.collide(None, None, x, y):
                        break
            enemy = deepcopy(enemy)
            enemy.x = x
            enemy.y = y
            self.enemies.append(enemy)
        def take(self):
            if len(self.map[hero.y][hero.x][1]):
                it = self.map[hero.y][hero.x][1].pop()
                if isinstance(it, item):
                    hero.got(stack(it, 1))
                else:
                    hero.got(it)
        def move(self, direction):
            hero.direction = direction
            hero.busy = 10
            hero.locked = True
            hero.stat = "walk"

            coll = self.collide(hero, direction)
            if not coll:
                self.go(hero, direction)
                if hero.hp < hero.max_hp and hero.food > 0:
                    hero.hp += 1
                    hero.food -= 1
                if hero.food < 1:
                    hero.hp -= 1

            elif coll[0] == "npc":
                self.talk(coll[1])
            elif coll[0] == "enemy":
                self.attack(hero, coll[1])

            x = hero.x
            y = hero.y
            for i in self.exits:
                if i[0] == x and i[1] == y:
                    Show("level_change", g = self, exit = i)()
            else:
                self.enemies_turn()
        def enter_level(self, exit):
            Hide("level")()
            level = eval(exit[2])

            for i in level.exits:
                if i[3] == exit[3]:
                    doorway = i
                    hero.x, hero.y = i[0], i[1]
                    break
            Show("level", g = level, direction = doorway[4])()
            # hero.x, hero.y = level.exits[exit[3]][0], level.exits[exit[3]][1]
            t = []
            for j in level.enemies:
                if not j.stat == "dead":
                    t.append(j)
            level.enemies = t
        def go(self, actor, direction):
            if direction == "up":
                actor.y -= 1
            elif direction == "left":
                actor.x -= 1
            elif direction == "down":
                actor.y += 1
            elif direction == "right":
                actor.x += 1
        def talk(self, actor):
            actor.face(hero)
            Call(actor.name.lower())()
        def attack(self, attacker, target):
            global talking_to
            if attacker == hero:
                talking_to = target
            else:
                talking_to = attacker
            crit = renpy.random.randint(-2, 2)
            damage = (attacker.total_attack + crit) - target.armor
            if damage < 1:
                damage = 1
            target.hp -= damage
            if target.hp < 1:
                target.direction = ""
                target.stat = "dead"
                msg.msg(target.stat)

        def walk(self, person, direction):
            person.direction = direction
            person.busy = 10
            person.locked = True
            person.stat = "walk"
            
            coll =  self.collide(person, direction)
            if not coll:
                self.go(person, direction)

        def enemies_turn(self):
            for i in self.enemies:
                if not i.stat == "dead":
                    direction = i.face(hero, False, True)
                    if self.collide(i, direction) == "player":
                        self.attack(i, hero)
                    elif self.collide(i, direction):
                        direction = renpy.random.choice(["up", "left", "down", "right"])
                    self.walk(i, direction)

transform level_change_fade:
    alpha 0
    ease .2 alpha 1
    pause .5
    ease .2 alpha 0
screen level_change(g, exit):
    # modal True
    zorder -1
    add "#040000" at level_change_fade
    timer .2 action Function(g.enter_level, exit = exit)
    timer .9 action Hide("level_change")
screen level(g, direction):
    zorder -2

    timer .5 action Function(g.move, direction)
    default scale = 2.0
    hbox:
        align .5,.0 spacing 10
        bar value ScreenVariableValue("scale", 3.0, offset=1.0) xysize 500,40
        button:
            ysize 40 xpadding 10
            text "reset" align .5,.5
            action SetScreenVariable("scale", 2.0)
    frame:
        ysize 860 yalign .0 background None
        fixed:
            fit_first True
            at zoom(scale)
            vbox:
                spacing 0
                for ii in g.map:
                    hbox:
                        spacing 0
                        for i in ii:
                            if i[0] == "-1":
                                frame:
                                    background None xysize(g.size,g.size)
                            else:
                                frame:
                                    background g.set[int(i[0])]
                                    xysize(g.size,g.size)
                                    if len(i[1]):
                                        add i[1][0].icon align .5,.5 at zoom(.5)
            for i in g.npc:
                frame:
                    xysize(g.size, g.size) background None at player_move(i.x*g.size, i.y*g.size) align .0,.0
                    add "{} {} {}".format(i.name, i.direction, i.stat) align(.5,.5) yoffset -8
            for i in g.enemies:
                frame:
                    xysize(g.size, g.size) background None at player_move(i.x*g.size, i.y*g.size) align .0,.0
                    add "{} {} {}".format(i.name, i.direction, i.stat) align(.5,.5) yoffset -8

            frame:
                xysize(g.size, g.size) background None at player_move(hero.x*g.size, hero.y*g.size) align .0,.0
                add "{} {} {}".format(hero.name, hero.direction, hero.stat) align(.5,.5) yoffset -8

    if hero.busy > 0:
        timer .06 repeat True action Function(hero.tick)
    if hero.locked:
        timer .32 repeat True action Function(hero.unlock)
        key "w" action NullAction()
        key "a" action NullAction()
        key "s" action NullAction()
        key "d" action NullAction()
    else:
        key "w" action Function(g.move, "up")
        key "a" action Function(g.move, "left")
        key "s" action Function(g.move, "down")
        key "d" action Function(g.move, "right")
        key "repeat_w" action Function(g.move, "up")
        key "repeat_a" action Function(g.move, "left")
        key "repeat_s" action Function(g.move, "down")
        key "repeat_d" action Function(g.move, "right")
    key "e" action Function(g.take)
    vbox:
        align .0,.0
        text "{}   {},{}".format(g.name, hero.x, hero.y) color "#ffd"




    drag:
        align .99,.4
        frame:
            vbox:
                spacing 10
                text "Tests"
                button:
                    text "Spawn"
                    action Function(g.spawn, demon)
                button:
                    text "Face"
                    action Function(thora.face, hero)
                button:
                    text "Face way"
                    action Function(thora.face, hero, True)
transform player_move(x, y):
    linear .45 xpos x ypos y

