﻿# default hero = inventory_class(
#     "You",
#     223,
#     [
#         bronze_chestplate,
#         iron_chestplate,
#         engraved_chestplate,
#         steel_chestplate,
#         ancient_armor,

#         iron_shoes,
#         leather_shoes,

#         golden_gloves,
#         half_gloves,
#         royal_gloves,

#         bronze_helmet,
#         engraved_helmet,
#         golden_helmet,
#         horny_hood,
#         rain_collector_helmet,
#         royal_helmet,
#         rusty_helmet,

#         dual_lion_shield,
#         lion_shield,
#         round_shield,
#         sun_shield,
#         wall_shield,

#         axe,
#         blade_mace,
#         curvy_dagger,
#         dual_axe,
#         katana,
#         long_dagger,
#         rough_sword,
#         short_sword,
#         spiked_stick,
#         wavy_dagger,
#         wooden_hammer,
#     ]
# )

screen hud():
    style_prefix "hud"
    fixed:
        xysize 1920,307 yalign 1.0
        add "hud"

        hbox: #-------------Player
            xalign 0.0 spacing 0
            fixed:
                add hero.portrait
                add "portrait_frame"
            vbox:
                spacing 4 yalign 1.0 yoffset -40
                text hero.name
                fixed:
                    bar value hero.hp range hero.max_hp xysize 260,36 right_bar "bar_empty" left_bar "bar_hp"
                    text "[hero.hp]/[hero.max_hp]"
                fixed:
                    bar value hero.food range hero.max_food xysize 260,36 right_bar "bar_empty" left_bar "bar_food"
                    text "[hero.food]/[hero.max_food]"
                fixed:
                    bar value hero.exp range 100 xysize 260,36 right_bar "bar_empty" left_bar "bar_exp"
                    text "level [hero.level]"
            vbox:
                spacing 4 yalign 1.0 offset 10,-40
                hbox:
                    spacing 4
                    add "rpg/attack.png"
                    text "[hero.total_attack]"
                hbox:
                    spacing 4
                    add "rpg/armor.png"
                    text "[hero.total_armor]"
                hbox:
                    spacing 4
                    add "rpg/cash.png"
                    text "[hero.cash]"

        hbox: #-------------enemy
            xalign 1.0 spacing 0
            vbox:
                spacing 4 yalign 1.0 offset -10,-40
                hbox:
                    spacing 4
                    text "[talking_to.total_attack]"
                    add "rpg/attack.png"
                hbox:
                    spacing 4
                    text "[talking_to.total_armor]"
                    add "rpg/armor.png"
                hbox:
                    spacing 4
                    text "[talking_to.cash]"
                    add "rpg/cash.png"
            vbox:
                spacing 4 yalign 1.0 yoffset -40
                text talking_to.name
                fixed:
                    bar value talking_to.hp range talking_to.max_hp xysize 260,36 right_bar "bar_empty" left_bar "bar_hp"
                    text "[talking_to.hp]/[talking_to.max_hp]"
                fixed:
                    bar value talking_to.food range talking_to.max_food xysize 260,36 right_bar "bar_empty" left_bar "bar_food"
                    text "[talking_to.food]/[talking_to.max_food]"
                fixed:
                    bar value talking_to.exp range 100 xysize 260,36 right_bar "bar_empty" left_bar "bar_exp"
                    text "level [talking_to.level]"
            fixed:
                add talking_to.portrait
                add "portrait_frame"
        vbox: #-------------items
            at items_pos(bool(renpy.get_screen("say"))*300)
            align .5,1.0 yoffset -20 spacing 8
            hbox:
                spacing 8
                for i in ["left", "hands", "head", "neck", "right"]:
                    button:
                        background None padding 0,0
                        action Function(hero.get_filtered_items, i)
                        fixed:
                            add "item_frame"
                            if len(player.equipment[i]):
                                add player.equipment[i][0].icon
            hbox:
                spacing 8
                for i in ["fingers", "feet", "chest", "quick_2", "bag"]:
                    button:
                        background None padding 0,0
                        action Function(hero.get_filtered_items, i)
                        fixed:
                            add "item_frame"
                            if len(player.equipment[i]):
                                add player.equipment[i][0].icon

transform items_pos(y):
    ease .2 yoffset y

screen select_item(items, inv, filter):
    modal True
    button:
        background "#000a"
        action Hide("select_item")

    frame:
        align .5,1.0 yoffset -250 background "#000a"
        hbox:
            box_wrap True spacing 4 box_wrap_spacing 4
            for i in items:
                button: # Item
                    xysize 68,68 padding 0,0 background "item_frame"
                    action Function(inv.item_equip, i.item, filter), Hide("select_item")
                    tooltip i
                    fixed:
                        add i.item.icon
                        if i.quantity > 1:
                            text str(i.quantity) size 22 align 1.0,1.0

            if len(items) == 0:
                text "You have no item for that." color "#fe0"

style hud_text:
    align (.5,.5)
    size 22
    color "#000"
    font "fonts/Hardpixel.OTF"
style hud_fixed:
    fit_first True
init python:
    config.overlay_screens.append("hud")