﻿init python:
    def return_mouse_pos():
        return renpy.get_mouse_pos()

    class inventory_class:
        def __init__(self, cash = 0, items = [], markup = 1.0, bags = [[42, "Backpack"], [4, "Pockets"]]):
            self.cash = cash
            self.items = []
            for i in items:
                if isinstance(i, item):
                    self.items.append(stack(i, 1))
                else:
                    self.items.append(i)
                
            self.markup = markup

            self.bags = []
            for i in bags:
                self.bags.append(i)
            b = 1
            for i in self.bags: # Bag size
                b += i[0]
            for i in range(b - len(self.items)): # Add empty slots
                self.items.append(None)
            self.current_bag = [0, self.bags[0][0], 0] # Set first bag

            self.bag_x = 0
            self.selected = None
        def dragged(self, drags, drop):
            self.bag_x = drags[0].x
            renpy.restart_interaction()
        def clicked(self, index):
            if self.items[index] and self.items[-1] and self.items[-1].item == self.items[index].item:
                self.items[index].quantity += self.items[-1].quantity
                self.items[-1] = None
            else:
                self.items[-1], self.items[index] = self.items[index], self.items[-1]

        def set_bag(self, index):
            start = 0
            for n, i in enumerate(self.bags):
                if n < index:
                    start += i[0]
            end = start + self.bags[index][0]
            self.current_bag = [start, end, index]
        def add_bag(self, bag):
            self.bags.append(bag)
            for i in range(bag[0]):
                self.items.append(None)
        def move_bag(self, bag, target):
            pass

        def has(self, items):
            got = 0
            if not isinstance(items, list):
                items = [items]
            for i in items:
                for j in self.items:
                    if j:
                        if i.item == j.item:
                            if j.quantity >= i.quantity:
                                got += 1
                                break
                else:
                    return False
            if got < len(items):
                return False
            else:
                return True
        def add_item(self, item):
            for i in self.items:
                if i:
                    if i.item == item.item:
                        i.quantity += item.quantity
                        return True
            else:
                for n,i in enumerate(self.items):
                    if i == None:
                        self.items[n] = item
                        return True
                else:
                    return False
        def remove_item(self, item):
            for n,i in enumerate(self.items):
                if i:
                    if i.item == item.item:
                        if i.quantity > item.quantity:
                            i.quantity -= item.quantity
                            return "done"
                        elif i.quantity == item.quantity:
                            self.items[n] = None
                            return "done"
                        else:
                            return "Not enough items"
            else:
                return "Doesn't exist"
        def got(self, items, announce = True):
            if not isinstance(items, list):
                items = [items]
            rejects = []
            for i in items:
                if isinstance(i, int):
                    self.cash += i
                    if announce:
                        msg.msg("{} got {} cash.".format(self.name, i))
                else:
                    if not self.add_item(i):
                        rejects.append(i)
                        msg.msg("{}'s bags are full.".format(self.name))
                    else:
                        if announce:
                            msg.msg("{} got {}, {}.".format(self.name, i.quantity, i.item.name))
        def drop(self, items, announce = True):
            if not isinstance(items, list):
                items = [items]
            rejects = []
            for i in items:
                response = self.remove_item(i)
                if not response == "done":
                    rejects.append(i)
                if announce:
                    if response == "Not enough items":
                        msg.msg("{} don't have that many.".format(self.name))
                    elif response == "Doesn't exist":
                        msg.msg("{} don't have that Item..".format(self.name))
                    else:
                        msg.msg("{} throw {}, {}.".format(self.name, i.quantity, i.item.name))

        def select(self, index):
            self.selected = index
        def discard(self):
            self.items[self.selected] = None
            self.selected = None
        def eat(self):
            # eating code goes here
            self.items[self.selected].quantity -= 1
            if self.items[self.selected].quantity < 1:
                self.items[self.selected] = None
                self.selected = None
        def use(self):
            # use code goes here
            self.items[self.selected].quantity -= 1
            if self.items[self.selected].quantity < 1:
                self.items[self.selected] = None
                self.selected = None
        def pick_one(self):
            if self.items[-1] == None:
                self.items[-1] = stack(self.items[self.selected].item, 1)
            else:
                self.items[-1].quantity += 1
            self.items[self.selected].quantity -= 1
            if self.items[self.selected].quantity < 1:
                self.items[self.selected] = None
                self.selected = None

        def give(self, recipient, items):
            recipient.got(items)
            self.drop(items)
        def pay(self, recipient, amount):
            if self.cash >= amount:
                recipient.got(amount)
                self.cash -= amount
            else:
                msg.msg("Not enough money.")

screen inventory(inv):
    style_prefix "inventory"
    default selected = None
    drag:
        align .5,.5
        vbox:
            frame:
                padding 10,10 xsize 40+(128*5)
                vbox:
                    text inv.name
                    hbox: # Bags
                        xfill True
                        hbox:
                            for n, i in enumerate(inv.bags):
                                button:
                                    text i[1]
                                    action Function(inv.set_bag, n), SelectedIf(inv.current_bag[2] == n)
                        text str(inv.cash) align 1.0,.5
                    hbox:
                        box_wrap True spacing 4 box_wrap_spacing 4
                        for i in range(inv.current_bag[0], inv.current_bag[1]):
                            button: # Item
                                xysize 128,128 padding 0,0
                                action Function(inv.clicked, i), Function(inv.select, None)
                                if inv.items[i]:
                                    alternate Function(inv.select, i)
                                    tooltip inv.items[i]
                                    fixed:
                                        add inv.items[i].item.icon
                                        # text inv.items[i].item.name size 20
                                        if not inv.items[i].quantity == 1:
                                            frame:
                                                align 1.0,1.0 padding 4,4
                                                text str(inv.items[i].quantity) size 20
                                else:
                                    alternate Function(inv.select, None)
            if inv.selected != None:
                hbox:
                    fixed:
                        fit_first True
                        add inv.items[inv.selected].item.icon
                        if not inv.items[inv.selected].quantity == 1:
                            frame:
                                align 1.0,1.0 padding 4,4
                                text str(inv.items[inv.selected].quantity) size 20
                    hbox:
                        yalign .5
                        button:
                            text _("Pick one")
                            action Function(inv.pick_one)
                        if isinstance(inv.items[inv.selected].item, food):
                            button:
                                text _("Eat")
                                action Function(inv.eat)
                        button:
                            text _("Use")
                            action NullAction()
                        button:
                            text _("Discard")
                            action Function(inv.discard)

    # Holding
    default mouse = (0,0)
    if inv.items[-1]:
        timer 0.02 repeat True action SetScreenVariable("mouse", renpy.get_mouse_pos())
        frame:
            xysize 128,128 pos mouse padding 0,0 background None
            at holding_item_anim
            fixed:
                add inv.items[-1].item.icon
                # text inv.holding.item.name size 20
                if not inv.items[-1].quantity == 1:
                    frame:
                        align 1.0,1.0 padding 4,4
                        text str(inv.items[-1].quantity) size 20


    drag: # Tests remove these later
        pos 100,100
        frame:
            vbox:
                text "Tests"
                button:
                    text "Add item"
                    action Function(inv.got, stack(renpy.random.choice(all_items), 1))
                button:
                    text "Add items"
                    action Function(inv.got, [stack(all_items[0], 1), stack(all_items[1], 1), stack(all_items[2], 1), stack(all_items[3], 1), stack(all_items[4], 1), stack(all_items[5], 1)])
                button:
                    text "Add Money"
                    action Function(inv.got, renpy.random.randint(0,100))
                button:
                    text "Add bag"
                    action Function(inv.add_bag, [5, "test"])

style inventory_text:
    color "#fff"
style inventory_frame:
    background "#444"
    padding (10,10)
style inventory_button:
    background Frame("inventory/icons/_frame.png", 16,16)
    padding (10,10)
style inventory_hbox:
    spacing 4
style inventory_vbox:
    spacing 4

transform holding_item_anim:
    alpha 0
    pause .05
    ease .1 alpha 1

# # A button to open and close the inventory
# screen inventory_button():
#     style_prefix "inventory"
#     vbox:
#         button:
#             margin 20,20
#             text _("Inventory")
#             action Show("inventory", inv = hero, _tag = hero.name)
#         # button:
#         #     margin 20,20
#         #     text _("Nana's inventory")
#         #     action Show("inventory", inv = nana, _tag = hero.name)

# init python:
#         config.overlay_screens.append("inventory_button")


