﻿init python:
    import pygame
    class player_unit(actor, equip, inventory_class):
        def __init__(self, name, x, y, level = 1, portrait = "no_portrait"):
            actor.__init__(self, name, x, y, level, portrait)
            equip.__init__(self)
            inventory_class.__init__(self, cash = 0, items = [bronze_chestplate], markup = 1.0, bags = [[42, "Backpack"], [4, "Pockets"]])

    def create_animations(name, type = "enemy"):
        img = "rpg/{}/{}/sheet.png".format(type, name)
        
        n = "{} down idle".format(name)
        d = Crop((32, 0, 32, 32), img)
        # d = DynamicDisplayable(show_countdown)
        renpy.image(n, d)

        n = "{} up idle".format(name)
        d = Crop((32, 96, 32, 32), img)
        renpy.image(n, d)
        
        n = "{} left idle".format(name)
        d = Crop((32, 32, 32, 32), img)
        renpy.image(n, d)

        n = "{} right idle".format(name)
        d = Crop((32, 64, 32, 32), img)
        renpy.image(n, d)

        n = "{} down walk".format(name)
        d = Animation([
            Crop((0, 0, 32, 32), img),
            Crop((32, 0, 32, 32), img),
            Crop((64, 0, 32, 32), img),
            Crop((32, 0, 32, 32), img)
            ], .1)
        renpy.image(n, d)

        n = "{} up walk".format(name)
        d = Animation([
            Crop((0, 96, 32, 32), img),
            Crop((32, 96, 32, 32), img),
            Crop((64, 96, 32, 32), img),
            Crop((32, 96, 32, 32), img)
            ], .1)
        renpy.image(n, d)

        n = "{} left walk".format(name)
        d = Animation([
            Crop((0, 32, 32, 32), img),
            Crop((32, 32, 32, 32), img),
            Crop((64, 32, 32, 32), img),
            Crop((32, 32, 32, 32), img)
            ], .1)
        renpy.image(n, d)

        n = "{} right walk".format(name)
        d = Animation([
            Crop((0, 64, 32, 32), img),
            Crop((32, 64, 32, 32), img),
            Crop((64, 64, 32, 32), img),
            Crop((32, 64, 32, 32), img)
            ], .1)
        renpy.image(n, d)

        n = "{}  dead".format(name)
        d = Crop((16, 16, 16, 32), img)
        renpy.image(n, d)
        return img
    
init python: # credits to hell_oh_world and Alex on lemmasoft for helping me figure out this part
    def animation(st, at, frames=[], interval=None):
        frame_count = len(frames)
        if interval is None:
            interval = 1 / float(frame_count)
        return frames[int((st // interval) % frame_count)], interval

    def Animation(frames, interval=0.08):
        return DynamicDisplayable(animation, frames=frames, interval=interval)


#---------------------------------------- Hero
define you_sheet = create_animations("You", "npc")
default hiro = Character("You")
default player = player_unit(
    "You",
    0,0,
    renpy.random.randint(1,4),
    "player_portrait"
)
default hero = player
default nobody = player_unit(
    "",
    0,0,

)
python:
    nobody.heath = hp
default talking_to = nobody
#---------------------------------------- NPC
define laria_sheet = create_animations("Laria", "npc")
default laria = player_unit(
    "Laria",
    0,0,
    2,
    "laria_portrait"
)


define thora_sheet = create_animations("Thora", "npc")
default thora = player_unit(
    "Thora",
    0,0,
    5,
    "thora_portrait"
)



#---------------------------------------- Enemy
define demon_sheet = create_animations("Demon")
default demon = player_unit(
    "Demon",
    0,0,
)
#---------------------------------------- Levels

default larias_room = level_class(
    _("Small room"),
    32,
    ["labyrinth ground", "rpg/levels/larias_room.csv"],
    objects = [[1,5,spiked_stick]],
    exits = [[4, 0, "the_well", 1, "down"]],
    npc = [
        [laria, 3, 5],
    ]
)
default the_well = level_class(
    _("The well"),
    32,
    ["labyrinth ground", "rpg/levels/the_well.csv"],
    objects = [[17,4,bronze_chestplate]],
    exits = [
        [24, 9, "larias_room", 1, "up"],
        [3, 0, "corridor_3", 2, "down"]
        ],
    enemies = [[demon, 18, 3]]
)
default corridor_3 = level_class(
    _("Corridor 3"),
    32,
    ["labyrinth ground", "rpg/levels/corridor_3.csv"],
    exits = [
        [20, 8, "the_well", 2, "up"],
        [20, 4, "level_2", 3, "down"],
        [2, 7, "level_5", 5, "up"],
        [9, 0, "corridor_5", 4, "down"],
        ],
    enemies = [[demon, 2, 5]]
)
default level_2 = level_class(
    _("Level 2"),
    32,
    ["labyrinth ground", "rpg/levels/level_2.csv"],
    objects = [[25,9,half_gloves]],
    exits = [
        [2, 7, "corridor_3", 3, "up"],
        [25, 1, "corridor_1", 9, "down"],
        ],
    enemies = [[demon, 2, 1], [demon, 25, 8]]
)
default level_5 = level_class(
    _("Level 5"),
    32,
    ["labyrinth ground", "rpg/levels/level_5.csv"],
    objects = [[15,7,iron_shoes]],
    exits = [
        [23, 0, "corridor_3", 5, "down"],
        [19, 1, "corridor_4", 6, "down"],
        [15, 0, "corridor_4", 7, "down"],
        [7, 1, "corridor_4", 8, "down"],
        ],
    enemies = [[demon, 5, 5]]
)
default corridor_4 = level_class(
    _("Corridor 4"),
    32,
    ["labyrinth ground", "rpg/levels/corridor_4.csv"],
    exits = [
        [13, 10, "level_5", 6, "up"],
        [9, 9, "level_5", 7, "up"],
        [1, 10, "level_5", 8, "up"],
        ],
)
default corridor_5 = level_class(
    _("Corridor 5"),
    32,
    ["labyrinth ground", "rpg/levels/corridor_5.csv"],
    exits = [
        [4, 11, "corridor_3", 4, "up"],
        [6, 1, "corridor_2", 12, "down"],
        ],
)
default corridor_1 = level_class(
    _("Corridor 1"),
    32,
    ["labyrinth ground", "rpg/levels/corridor_1.csv"],
    exits = [
        [3, 9, "level_2", 9, "up"],
        [1, 0, "level_3", 10, "down"],
        ],
    enemies = [[demon, 1, 3]]
)
default level_3 = level_class(
    _("Level 1"),
    32,
    ["labyrinth ground", "rpg/levels/level_3.csv"],
    exits = [
        [3, 10, "corridor_1", 10, "up"],
        [25, 10, "level_4", 11, "up"],
        ],
    enemies = [[demon, 13, 5], [demon, 18, 4]]
)
default level_4 = level_class(
    _("Level 4"),
    32,
    ["labyrinth ground", "rpg/levels/level_4.csv"],
    objects = [[2,6,bronze_helmet], [26,2,royal_helmet]],
    exits = [
        [2, 0, "level_3", 11, "down"],
        ],
)
default corridor_2 = level_class(
    _("Corridor 2"),
    32,
    ["labyrinth ground", "rpg/levels/corridor_2.csv"],
    exits = [
        [7, 4, "corridor_5", 12, "up"],
        [18, 0, "twin_corridors", 13, "down"],
        ],
    enemies = [[demon, 1, 2]]
)
default twin_corridors = level_class(
    _("Twin corridors"),
    32,
    ["labyrinth ground", "rpg/levels/twin_corridors.csv"],
    exits = [
        [7, 11, "corridor_2", 13, "up"],
        [9, 0, "big_hall", 15, "down"],
        [6, 0, "big_hall", 14, "down"],
        [12, 0, "big_hall", 16, "down"],
        [15, 0, "big_hall", 17, "down"],
        ],
    enemies = [[demon, 13, 7], [demon, 2, 2]]
)
default big_hall = level_class(
    _("Big hall"),
    32,
    ["labyrinth ground", "rpg/levels/big_hall.csv"],
    exits = [
        [12, 11, "twin_corridors", 15, "up"],
        [9, 11, "twin_corridors", 14, "up"],
        [15, 11, "twin_corridors", 16, "up"],
        [18, 11, "twin_corridors", 17, "up"],
        ],
    enemies = [[demon, 4, 7], [demon, 14, 3], [demon, 21, 6], [demon, 24, 2]]
)












label level_1:
    show screen level_change(corridor_3, corridor_3.exits[0])
    "{w=1.5}{nw}"
    $ hero.direction = "left"
    "{w=.5}{nw}"
    $ hero.direction = "right"
    "{w=.5}{nw}"
    $ hero.direction = "down"
    "Yep"
    "I'm lost!"
    window hide
label game_loop:
    pause
    jump game_loop










